 @library spritlib
;************** Start of Fargo library ***************



        label   get_background_bw
 movem.l d0-d2/a0-a1,-(a7)
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 eori.b  #%1111,d1
 lea     $4440,a1
 adda.l  d2,a1
 moveq   #15,d0
BW_Get_Next_Row:
 move.l  (a1),(a0)+
 add.l   #30,a1 
 dbra    d0,BW_Get_Next_Row
 movem.l (a7)+,d0-d2/a0-a1
 rts



        label    get_background_g
 movem.l d0-d2/a0-a2,-(a7)
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 eori.b  #%1111,d1
 lea     $4440,a2
 adda.l  d2,a1
 adda.l  d2,a2
 moveq   #15,d0
G_Get_Next_Row:
 move.l  (a1),(a0)+  ;greyplane
 move.l  (a2),(a0)+  ;normal
 add.l   #30,a1
 add.l   #30,a2
 dbra    d0,G_Get_Next_Row
 movem.l (a7)+,d0-d2/a0-a2
 rts



        label    put_sprite_bw
 movem.l d0-d3/a0-a1,-(a7)
 lsl.l   #6,d2
 adda.l  d2,a0
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 eori.b  #%1111,d1
 lea     $4440,a1
 adda.l  d2,a1
 moveq   #15,d0
BW_Next_Row:
 clr.l   d2
 clr.l   d3
 move.w  32(a0),d3  ;lit le masque
 rol.l   d1,d3
 not.l   d3
 and.l   d3,(a1)
 move.w  (a0)+,d2   ;dessin
 lsl.l   d1,d2
 or.l    d2,(a1)
 add.l   #30,a1
 dbra    d0,BW_Next_Row
 movem.l (a7)+,d0-d3/a0-a1
 rts



        label    put_sprite_g
 movem.l d0-d3/a0-a2,-(a7)
 move.w  d2,d3   ;multiply d2 by 96
 lsl.w   #1,d2   ;d2*2
 add.w   d3,d2   ;d2*2+d2=3*d2
 lsl.l   #5,d2   ;(3*d2)*32=96*d2  (96=3*(16*2))
 adda.l  d2,a0
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 eori.b  #%1111,d1
 lea     $4440,a2
 adda.l  d2,a1
 adda.l  d2,a2
 moveq   #15,d0
G_Next_Row:
 clr.l   d3
 move.w  64(a0),d3   ;lit le masque et l'applique aux deux plans
 rol.l   d1,d3
 not.l   d3
 and.l   d3,(a1)
 and.l   d3,(a2)
 clr.l   d2
 move.w  32(a0),d2   ;greyplane
 lsl.l   d1,d2
 or.l    d2,(a1)
 clr.l   d2
 move.w  (a0)+,d2     ;normal
 lsl.l   d1,d2
 or.l    d2,(a2)
 add.l   #30,a1
 add.l   #30,a2
 dbra    d0,G_Next_Row
 movem.l (a7)+,d0-d3/a0-a2
 rts



        label    put_background_bw
 movem.l d0-d2/a0-a1,-(a7)
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 eori.b  #%1111,d1
 lea     $4440,a1
 adda.l  d2,a1
 moveq   #15,d0
BW_Put_Next_Row:
 move.l  (a0)+,(a1)
 add.l   #30,a1 
 dbra    d0,BW_Put_Next_Row
 movem.l (a7)+,d0-d2/a0-a1
 rts



        label    put_background_g
 movem.l d0-d2/a0-a2,-(a7)
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 eori.b  #%1111,d1
 lea     $4440,a2
 adda.l  d2,a1
 adda.l  d2,a2
 moveq   #15,d0
G_Put_Next_Row:
 move.l  (a0)+,(a1)  ;greyplane
 move.l  (a0)+,(a2)  ;normal
 add.l   #30,a1
 add.l   #30,a2
 dbra    d0,G_Put_Next_Row
 movem.l (a7)+,d0-d2/a0-a2
 rts



;*************** End of Fargo library ****************
 reloc_open
 reloc_close
 end